<template>
	<div class="app-container">
		<el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="98px">
			<el-form-item label="工单编码" prop="workorderCode">
				<el-input
					v-model="queryParams.workorderCode"
					placeholder="请输入工单编码"
					clearable
					@keyup.enter.native="handleQuery"
				/>
			</el-form-item>
			<el-form-item label="产品规格型号" prop="productSpc">
				<el-input
					v-model="queryParams.productSpc"
					placeholder="请输入产品规格型号"
					clearable
					@keyup.enter.native="handleQuery"
				/>
			</el-form-item>
			<el-form-item label="产品名称" prop="productName">
				<el-input
					v-model="queryParams.productName"
					placeholder="请输入产品名称"
					clearable
					@keyup.enter.native="handleQuery"
				/>
			</el-form-item>
			<el-form-item>
				<el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
				<el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
			</el-form-item>
		</el-form>

		<el-row :gutter="10" class="mb8">
			<el-col :span="1.5">
				<el-button
					type="primary"
					plain
					icon="el-icon-plus"
					size="mini"
					@click="handleAdd"
					v-hasPermi="['mes:validate:add']"
				>新增</el-button>
			</el-col>
			<el-col :span="1.5">
				<el-button
					type="success"
					plain
					icon="el-icon-edit"
					size="mini"
					:disabled="single"
					@click="handleUpdate"
					v-hasPermi="['mes:validate:edit']"
				>修改</el-button>
			</el-col>
			<el-col :span="1.5">
				<el-button
					type="danger"
					plain
					icon="el-icon-delete"
					size="mini"
					:disabled="multiple"
					@click="handleDelete"
					v-hasPermi="['mes:validate:remove']"
				>删除</el-button>
			</el-col>
			<el-col :span="1.5">
				<el-button
					type="warning"
					plain
					icon="el-icon-download"
					size="mini"
					@click="handleExport"
					v-hasPermi="['mes:validate:export']"
				>导出</el-button>
			</el-col>
			<right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
		</el-row>

		<el-table v-loading="loading" :data="validateList" @selection-change="handleSelectionChange">
			<el-table-column type="selection" width="55" align="center" />
			<!-- 序号 -->
      <el-table-column type="index" align="center" :index="indexMethod" label="序号"/>
			<el-table-column label="工单编码" align="center" prop="workorderCode" />
			<el-table-column label="订单编码" align="center" prop="workorderCode" />
			<el-table-column label="产品名称" align="center" prop="productName" />
			<el-table-column label="产品型号" align="center" prop="productSpc" />
			<el-table-column label="准备类型" align="center" prop="validateType" />
			<el-table-column label="准备内容" align="center" prop="validateName" />
			<el-table-column label="准备状态" align="center" prop="validateStatus" />
			<el-table-column label="完成时间" align="center" prop="endTime" />
		</el-table>

		<pagination
			v-show="total>0"
			:total="total"
			:page.sync="queryParams.pageNum"
			:limit.sync="queryParams.pageSize"
			@pagination="getList"
		/>

		<!-- 添加或修改生产前准备记录报表对话框 -->
		<el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
			<el-form ref="form" :model="form" :rules="rules" label-width="80px">
				<el-form-item label="工单编码" prop="workorderCode">
					<el-input v-model="form.workorderCode" placeholder="请输入工单编码" />
				</el-form-item>
				<el-form-item label="工单名称" prop="workorderName">
					<el-input v-model="form.workorderName" placeholder="请输入工单名称" />
				</el-form-item>
				<el-form-item label="产品规格型号" prop="productSpc">
					<el-input v-model="form.productSpc" placeholder="请输入产品规格型号" />
				</el-form-item>
				<el-form-item label="产品名称" prop="productName">
					<el-input v-model="form.productName" placeholder="请输入产品名称" />
				</el-form-item>
				<el-form-item label="备注" prop="remark">
					<el-input v-model="form.remark" placeholder="请输入备注" />
				</el-form-item>
				<el-form-item label="预留字段1" prop="attr1">
					<el-input v-model="form.attr1" placeholder="请输入预留字段1" />
				</el-form-item>
				<el-form-item label="预留字段2" prop="attr2">
					<el-input v-model="form.attr2" placeholder="请输入预留字段2" />
				</el-form-item>
				<el-form-item label="预留字段3" prop="attr3">
					<el-input v-model="form.attr3" placeholder="请输入预留字段3" />
				</el-form-item>
				<el-form-item label="预留字段4" prop="attr4">
					<el-input v-model="form.attr4" placeholder="请输入预留字段4" />
				</el-form-item>
				<el-form-item label="工厂编码" prop="factoryCode">
					<el-input v-model="form.factoryCode" placeholder="请输入工厂编码" />
				</el-form-item>
			</el-form>
			<div slot="footer" class="dialog-footer">
				<el-button type="primary" @click="submitForm">确 定</el-button>
				<el-button @click="cancel">取 消</el-button>
			</div>
		</el-dialog>
	</div>
</template>

<script>
import { listValidate, getValidate, delValidate, addValidate, updateValidate } from "@/api/mes/validate";

export default {
	name: "Validate",
	data() {
		return {
			// 遮罩层
			loading: true,
			// 选中数组
			ids: [],
			// 非单个禁用
			single: true,
			// 非多个禁用
			multiple: true,
			// 显示搜索条件
			showSearch: true,
			// 总条数
			total: 0,
			// 生产前准备记录报表表格数据
			validateList: [],
			// 弹出层标题
			title: "",
			// 是否显示弹出层
			open: false,
			// 查询参数
			queryParams: {
				pageNum: 1,
				pageSize: 10,
				workorderCode: null,
				workorderName: null,
				productSpc: null,
				productName: null,
				status: null,
				attr1: null,
				attr2: null,
				attr3: null,
				attr4: null,
				factoryCode: null
			},
			// 表单参数
			form: {},
			// 表单校验
			rules: {
				workorderCode: [
					{ required: true, message: "工单编码不能为空", trigger: "blur" }
				],
			}
		};
	},
	created() {
		this.getList();
	},
	methods: {
	  indexMethod(index){
       return index+1 ;
    },
		/** 查询生产前准备记录报表列表 */
		getList() {
			this.loading = true;
			listValidate(this.queryParams).then(response => {
				this.validateList = response.rows;
				this.total = response.total;
				this.loading = false;
			});
		},
		// 取消按钮
		cancel() {
			this.open = false;
			this.reset();
		},
		// 表单重置
		reset() {
			this.form = {
				validateId: null,
				workorderCode: null,
				workorderName: null,
				productSpc: null,
				productName: null,
				status: null,
				remark: null,
				attr1: null,
				attr2: null,
				attr3: null,
				attr4: null,
				createBy: null,
				createTime: null,
				updateBy: null,
				updateTime: null,
				factoryCode: null
			};
			this.resetForm("form");
		},
		/** 搜索按钮操作 */
		handleQuery() {
			this.queryParams.pageNum = 1;
			this.getList();
		},
		/** 重置按钮操作 */
		resetQuery() {
			this.resetForm("queryForm");
			this.handleQuery();
		},
		// 多选框选中数据
		handleSelectionChange(selection) {
			this.ids = selection.map(item => item.validateId)
			this.single = selection.length!==1
			this.multiple = !selection.length
		},
		/** 新增按钮操作 */
		handleAdd() {
			this.reset();
			this.open = true;
			this.title = "添加生产前准备记录报表";
		},
		/** 修改按钮操作 */
		handleUpdate(row) {
			this.reset();
			const validateId = row.validateId || this.ids
			getValidate(validateId).then(response => {
				this.form = response.data;
				this.open = true;
				this.title = "修改生产前准备记录报表";
			});
		},
		/** 提交按钮 */
		submitForm() {
			this.$refs["form"].validate(valid => {
				if (valid) {
					if (this.form.validateId != null) {
						updateValidate(this.form).then(response => {
							this.$modal.msgSuccess("修改成功");
							this.open = false;
							this.getList();
						});
					} else {
						addValidate(this.form).then(response => {
							this.$modal.msgSuccess("新增成功");
							this.open = false;
							this.getList();
						});
					}
				}
			});
		},
		/** 删除按钮操作 */
		handleDelete(row) {
			const validateIds = row.validateId || this.ids;
			this.$modal.confirm('是否确认删除生产前准备记录报表编号为"' + validateIds + '"的数据项？').then(function() {
				return delValidate(validateIds);
			}).then(() => {
				this.getList();
				this.$modal.msgSuccess("删除成功");
			}).catch(() => {});
		},
		/** 导出按钮操作 */
		handleExport() {
			this.download('mes/validate/export', {
				...this.queryParams
			}, `validate_${new Date().getTime()}.xlsx`)
		}
	}
};
</script>
